/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.relatorios;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.sql.DataSource;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.WrongValueException;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Bandbox;
import org.zkoss.zul.Button;
import org.zkoss.zul.Checkbox;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Datebox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Radio;
import org.zkoss.zul.Textbox;
import org.zkoss.zul.Window;
import org.zkoss.zul.api.Row;

import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.Estado;
import com.rjconsultores.ventaboletos.entidad.GrupoRuta;
import com.rjconsultores.ventaboletos.entidad.Moneda;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.entidad.TipoPuntoVenta;
import com.rjconsultores.ventaboletos.relatorios.impl.RelatorioReceitaDiariaAgencia;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.service.EstadoService;
import com.rjconsultores.ventaboletos.service.GrupoRutaService;
import com.rjconsultores.ventaboletos.service.TipoPuntoVentaService;
import com.rjconsultores.ventaboletos.utilerias.DateUtil;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderEstadoSimple;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderPuntoVentaSimple;
import com.trg.search.Filter;

/**
 * 
 * @author Administrador
 */
@Controller("relatorioReceitaDiariaAgenciaController")
@Scope("prototype")
@SuppressWarnings({"unchecked", "rawtypes"})
public class RelatorioReceitaDiariaAgenciaController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private EstadoService estadoService;
	@Autowired
	private GrupoRutaService grupoRutaService;
	@Autowired
	private EmpresaService empresaService;
	@Autowired
	private TipoPuntoVentaService tipoPuntoVentaService;
	@Autowired
	private DataSource dataSourceRead;

	private List<Estado> lsEstado;
	private List<GrupoRuta> lsGrupoRuta;
	private List<Empresa> lsEmpresa;
	private List<TipoPuntoVenta> lsTipoPuntoVenta;

	private List<PuntoVenta> lsNumPuntoVenta;
	
	private Checkbox somenteCancelados;
	private Checkbox consideraTransferenciaPassagem;

	@Autowired
	private transient PagedListWrapper<PuntoVenta> plwPuntoVenta;

	private MyListbox puntoVentaList;
	
	private MyListbox estadoList;
	private MyListbox puntoVentaSelList;
	private Paging pagingPuntoVenta;

	private Bandbox bbPesquisaPuntoVenta;

	private Textbox txtPalavraPesquisa;
	private Combobox cmbEstado;
	private Combobox cmbMoeda;
	private Combobox cmbEmpresa;
	private Combobox cmbPuntoVenta;
	private Combobox cmbTipoPuntoVenta;
	private Combobox cmbReceitaImposto;
	private Combobox cmbGrupoRuta;
	private Datebox datInicial;
	private Datebox datFinal;
	private Checkbox chkExcessoBagagem;
	private Checkbox chkContemplarGap;
	private Radio rd1;
	private Radio radDataFechamento;
	private MyListbox puntoVentaConfiguracaoList;
	private Paging pagingPuntoVentaConfiguracao;
	private static final Logger log = LogManager.getLogger(RelatorioReceitaDiariaAgenciaController.class);
	public Checkbox getSomenteCancelados() {
		return somenteCancelados;
	}

	public void setSomenteCancelados(Checkbox somenteCancelados) {
		this.somenteCancelados = somenteCancelados;
	}
	

	public Checkbox getConsideraTransferenciaPassagem() {
		return consideraTransferenciaPassagem;
	}

	public void setConsideraTransferenciaPassagem(Checkbox consideraTransferenciaPassagem) {
		this.consideraTransferenciaPassagem = consideraTransferenciaPassagem;
	}

	public Datebox getDatInicial() {
		return datInicial;
	}

	public List<GrupoRuta> getLsGrupoRuta() {
		return lsGrupoRuta;
	}

	public void setLsGrupoRuta(List<GrupoRuta> lsGrupoRuta) {
		this.lsGrupoRuta = lsGrupoRuta;
	}

	public void setDatInicial(Datebox datInicial) {
		this.datInicial = datInicial;
	}

	public Datebox getDatFinal() {
		return datFinal;
	}

	public void setDatFinal(Datebox datFinal) {
		this.datFinal = datFinal;
	}

	public List<Estado> getLsEstado() {
		return lsEstado;
	}

	public void setLsEstado(List<Estado> lsEstado) {
		this.lsEstado = lsEstado;
	}

	public Combobox getCmbEstado() {
		return cmbEstado;
	}

	public void setCmbEstado(Combobox cmbEstado) {
		this.cmbEstado = cmbEstado;
	}

	public Combobox getCmbPuntoVenta() {
		return cmbPuntoVenta;
	}

	public void setCmbPuntoVenta(Combobox cmbPuntoVenta) {
		this.cmbPuntoVenta = cmbPuntoVenta;
	}

	public Combobox getCmbGrupoLinha() {
		return cmbGrupoRuta;
	}

	public void setCmbGrupoLinha(Combobox cmbGrupoLinha) {
		this.cmbGrupoRuta = cmbGrupoLinha;
	}

	public MyListbox getPuntoVentaList() {
		return puntoVentaList;
	}

	public void setPuntoVentaList(MyListbox puntoVentaList) {
		this.puntoVentaList = puntoVentaList;
	}

	public Paging getPagingPuntoVenta() {
		return pagingPuntoVenta;
	}

	public void setPagingPuntoVenta(Paging pagingPuntoVenta) {
		this.pagingPuntoVenta = pagingPuntoVenta;
	}

	public Textbox getTxtPalavraPesquisa() {
		return txtPalavraPesquisa;
	}

	public void setTxtPalavraPesquisa(Textbox txtPalavraPesquisa) {
		this.txtPalavraPesquisa = txtPalavraPesquisa;
	}

	public Bandbox getBbPesquisaPuntoVenta() {
		return bbPesquisaPuntoVenta;
	}

	public void setBbPesquisaPuntoVenta(Bandbox bbPesquisaPuntoVenta) {
		this.bbPesquisaPuntoVenta = bbPesquisaPuntoVenta;
	}

	public Checkbox getChkExcessoBagagem() {
		return chkExcessoBagagem;
	}

	public void setChkExcessoBagagem(Checkbox chkExcessoBagagem) {
		this.chkExcessoBagagem = chkExcessoBagagem;
	}

	public MyListbox getPuntoVentaSelList() {
		return puntoVentaSelList;
	}

	public void setPuntoVentaSelList(MyListbox puntoVentaSelList) {
		this.puntoVentaSelList = puntoVentaSelList;
	}

	public List<Empresa> getLsEmpresa() {
		return lsEmpresa;
	}

	public void setLsEmpresa(List<Empresa> lsEmpresa) {
		this.lsEmpresa = lsEmpresa;
	}

	public List<TipoPuntoVenta> getLsTipoPuntoVenta() {
		return lsTipoPuntoVenta;
	}

	public void setLsTipoPuntoVenta(List<TipoPuntoVenta> lsTipoPuntoVenta) {
		this.lsTipoPuntoVenta = lsTipoPuntoVenta;
	}

	public void onClick$btnExecutarRelatorio(Event ev) throws Exception {
		executarRelatorio();
	}

	public void onDoubleClick$puntoVentaList(Event ev) {

		PuntoVenta puntoVentaSel = (PuntoVenta) puntoVentaList.getSelected();
		puntoVentaSelList.addItemNovo(puntoVentaSel);

	}

	public void onDoubleClick$puntoVentaSelList(Event ev) {

		PuntoVenta puntoVentaSel = (PuntoVenta) puntoVentaSelList.getSelected();
		puntoVentaSelList.removeItem(puntoVentaSel);

	}

	public void onSelect$puntoVentaList(Event ev) {

	}

	public void onClick$btnLimpar(Event ev) {
		limparPesquisaAgencia();
	}

	public void onClick$btnPesquisa(Event ev) {
		executarPesquisa();
	}

	/**
	 * 
	 */
	private void limparPesquisaAgencia() {
		puntoVentaSelList.setData(new ArrayList<Object>());

	}

	/**
	 * 
	 */
	private void executarPesquisa() {
		HibernateSearchObject<PuntoVenta> puntoVentaBusqueda =
				new HibernateSearchObject<PuntoVenta>(PuntoVenta.class,
						pagingPuntoVenta.getPageSize());

		puntoVentaBusqueda.addFilterOr(Filter.like("nombpuntoventa", "%" + txtPalavraPesquisa.getText().trim().toUpperCase().concat("%")), Filter.like("numPuntoVenta", "%" + txtPalavraPesquisa.getText().trim().toUpperCase().concat("%")));

		puntoVentaBusqueda.addSortAsc("nombpuntoventa");

		puntoVentaBusqueda.addFilterEqual("activo", Boolean.TRUE);
		
		puntoVentaBusqueda.addFilterNotEqual("puntoventaId", -1);

		plwPuntoVenta.init(puntoVentaBusqueda, puntoVentaList, pagingPuntoVenta);

		if (puntoVentaList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("relatorioReceitaDiariaAgenciaController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}

	/**
	 * @throws Exception
	 * 
	 */
	
	private void executarRelatorio() throws Exception {

		Map<String, Object> parametros = new HashMap<String, Object>();
		StringBuilder filtro = new StringBuilder();
		
		parametros.put("DATA_INICIO", DateUtil.inicioFecha(this.datInicial.getValue()));
		parametros.put("DATA_FINAL", DateUtil.fimFecha(this.datFinal.getValue()));
		parametros.put("B_EXCLUI_BAGAGEM", chkExcessoBagagem.isChecked());
		parametros.put("B_CONTEMPLAR_GAP", chkContemplarGap.isChecked());
		parametros.put("B_DATA_FECHAMENTO", radDataFechamento.isChecked());
		parametros.put("NOME_RELATORIO", Labels.getLabel("relatorioReceitaDiariaAgenciaController.window.title"));
		parametros.put("ISDEVOLUCAODESTINO", rd1.isChecked() ? 0 : 1);
		parametros.put("USUARIO", UsuarioLogado.getUsuarioLogado().getUsuarioId().toString());
		parametros.put("SOMENTE_CANCELADOS", somenteCancelados.isChecked());
		parametros.put("TRANSFERENCIA_PASSAGENS", consideraTransferenciaPassagem.isChecked());

		parametros.put("BASE_CALCULO_IMPOSTO", Integer.valueOf(cmbReceitaImposto.getSelectedItem().getValue().toString()));
		
		if (cmbGrupoRuta.getSelectedItem() != null && lsGrupoRuta.get(cmbGrupoRuta.getSelectedIndex()).getGrupoRutaId() != null) {
			parametros.put("GRUPO_RUTA", lsGrupoRuta.get(cmbGrupoRuta.getSelectedIndex()).getGrupoRutaId());
		}

		lsNumPuntoVenta = new ArrayList(Arrays.asList(puntoVentaSelList.getData()));

		filtro.append("Agência(s): ");
		if (!lsNumPuntoVenta.isEmpty()) {
			parametros.put("NUMPUNTOVENTA", lsNumPuntoVenta);
			parametros.put("ISNUMPUNTOVENTATODOS", "N");
			filtro.append(lsNumPuntoVenta.size() + " selecionada(s);");
		}
		else {
			parametros.put("ISNUMPUNTOVENTATODOS", "S");
			filtro.append("Todas ;");
		}

		filtro.append("Estados(s): ");
		if (!estadoList.getSelectedsItens().isEmpty()) {
			parametros.put("ESTADO_ID", estadoList.getSelectedsItens());
			filtro.append(estadoList.getSelectedsItens().size() + " selecionado(s);");
		}
		else {
			filtro.append("Todos ;");
		}

		Comboitem itemEmpresa = cmbEmpresa.getSelectedItem();
		if (itemEmpresa != null) {
			Empresa empresa = (Empresa) itemEmpresa.getValue();
			parametros.put("EMPRESA_ID", empresa.getEmpresaId());
			parametros.put("EMPRESA_NOME", empresa.getNombempresa());
		}

		filtro.append(" Tipo Agência: ");
		Comboitem itemTipoPunto = cmbTipoPuntoVenta.getSelectedItem();
		if (itemTipoPunto != null && ((TipoPuntoVenta) cmbTipoPuntoVenta.getSelectedItem().getValue()).getTipoptovtaId() != -1) {
			TipoPuntoVenta tipoPuntoVenta = (TipoPuntoVenta) itemTipoPunto.getValue();
			parametros.put("TIPOPTOVTA_ID", tipoPuntoVenta.getTipoptovtaId().intValue());
			filtro.append(tipoPuntoVenta.getDesctipo() + ";");
		}
		else
			filtro.append("Todos;");

		if (chkContemplarGap.isChecked())
			filtro.append(" Contemplar GAP;");
		else
			filtro.append(" Desconsiderar GAP;");

		if (chkExcessoBagagem.isChecked())
			filtro.append(" Exclui Excesso de Bagagem;");
		else
			filtro.append(" Inclui Excesso de Bagagem;");

		filtro.append(" devolução na Agência: ");

		if (rd1.isChecked())
			filtro.append("Origem;");
		else
			filtro.append("Destino;");
		
		if (radDataFechamento.isChecked())
			filtro.append("Data de Fechamento;");
		else
			filtro.append("Data da Venda;");

		filtro.append(" Moeda: ");
		Comboitem itemMoeda = cmbMoeda.getSelectedItem();
		if (itemMoeda != null ) {
			Moneda moeda = (Moneda) itemMoeda.getValue();
			parametros.put("MOEDA_ID", moeda.getMonedaId());
			parametros.put("MOEDA_SIMBOLO", moeda.getSimbolo());
			filtro.append(moeda.getDescmoneda() + ";");
		}
		
		parametros.put("FILTROS", filtro.toString());

		RelatorioReceitaDiariaAgencia relatorio = new RelatorioReceitaDiariaAgencia(parametros, dataSourceRead.getConnection());
		if(relatorio.getPontoVendaConfiguracao()!=null && !relatorio.getPontoVendaConfiguracao().isEmpty() ) {
			final Window dialog = (Window) Executions.createComponents("/gui/utilerias/visualizarPontoVenda.zul", null, null);
			exibirDialog(dialog,  new ArrayList<PuntoVenta>(relatorio.getPontoVendaConfiguracao()));
		}

		Map args = new HashMap();
		args.put("relatorio", relatorio);

		openWindow("/component/reportView.zul",
				Labels.getLabel("relatorioReceitaDiariaAgenciaController.window.title"), args, MODAL);

	}
	
	private void exibirDialog(final Window dialog, List<PuntoVenta> puntoVentaList){
		try {
			Button visualizarAgencias = (Button) dialog.getFellow("visualizarAgencias");
		    puntoVentaConfiguracaoList = (MyListbox) dialog.getFellow("puntoVentaConfiguracaoList");
			puntoVentaConfiguracaoList.setItemRenderer(new RenderPuntoVentaSimple());
			puntoVentaConfiguracaoList.setData(puntoVentaList);
			pagingPuntoVentaConfiguracao = (Paging) dialog.getFellow("pagingPuntoVentaConfiguracao");
			pagingPuntoVentaConfiguracao.setPageSize(5);
			visualizarAgencias.addEventListener("onClick", new EventListener() {
				@Override
				public void onEvent(Event event) throws Exception {
					try{
						
						Row puntoVentaConfiguracaoRow = (Row) dialog.getFellow("puntoVentaConfiguracaoRow");
						if(puntoVentaConfiguracaoRow.isVisible()) {
							puntoVentaConfiguracaoList.setVisible(false);
							puntoVentaConfiguracaoRow.setVisible(false);
						}else {
							puntoVentaConfiguracaoList.setVisible(true);
							puntoVentaConfiguracaoRow.setVisible(true);
						}
					}catch(Throwable t){
						if (t instanceof WrongValueException){
							throw (WrongValueException)t;
						}
						
						Messagebox.show(Labels.getLabel("MSG.CONSTRAINT.DECIMALBOXISNOTANUMBER"),
								Labels.getLabel("editarCatalogoDeRutaController.window.title"),
								Messagebox.OK, Messagebox.EXCLAMATION);
					}
				}
			});

			//dialog.setMaximizable(true);
			dialog.doModal();

		} catch (Exception e) {
			log.error("", e);
		}
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		
		lsEstado = estadoService.obtenerTodos();
		lsEmpresa = empresaService.obtenerTodos();
		lsGrupoRuta = grupoRutaService.obtenerTodos();
		setLsTipoPuntoVenta(tipoPuntoVentaService.obtenerTodos());
		super.doAfterCompose(comp);

		estadoList.setItemRenderer(new RenderEstadoSimple());
		puntoVentaList.setItemRenderer(new RenderPuntoVentaSimple());
		puntoVentaSelList.setItemRenderer(new RenderPuntoVentaSimple());

		estadoList.setData(lsEstado);
	}

	public Combobox getCmbMoeda() {
		return cmbMoeda;
	}

	public void setCmbMoeda(Combobox cmbMoeda) {
		this.cmbMoeda = cmbMoeda;
	}

}
